config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resource :dashboard, only: [:show]
  root 'static_pages#index'
  get 'privacy', to: 'static_pages#privacy'
  get 'careers', to: 'static_pages#careers'
  get 'team', to: 'static_pages#team'
  resources :courses, only: [:index, :show] do
    resources :enrollments, only: :create
  end
  resources :lessons, only: [:show]
  namespace :instructor do
    resources :lessons, only: [:update]
    resources :sections, only: [:update] do
      resources :lessons, only: [:create]
    end
    resources :courses, only: [:new, :create, :show] do
      resources :sections, only: [:create]
    end
  end
end
# For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

app/models/lesson.rb
class Lesson < ApplicationRecord
  belongs_to :section
  mount_uploader :video, VideoUploader

  include RankedModel
  ranks :row_order, with_same: :section_id

  def next_lesson
    lesson = section.lessons.where("row_order > ?", self.row_order).rank(:row_order).first
    if lesson.blank? && section.next_section
      return section.next_section.lessons.rank(:row_order).first
    end
    return lesson
  end
end

app/controllers/instructor/lessons_controller.rb
class Instructor::LessonsController < ApplicationController

  before_action :authenticate_user!
  before_action :require_authorized_for_current_section, only: [:create]
  before_action :require_authorized_for_current_lesson, only: [:update]

  def create
    @lesson = current_section.lessons.create(lesson_params)
    redirect_to instructor_course_path(current_section.course)
  end

  def update
    current_lesson.update_attributes(lesson_params)
    render plain: 'updated!'
  end

  private

  def require_authorized_for_current_lesson
    if current_lesson.section.course.user != current_user
      render plain: 'Unauthorized', status: :unauthorized
    end
  end

  def current_lesson
    @current_lesson ||= Lesson.find(params[:id])
  end

  def require_authorized_for_current_section
    if current_section.course.user != current_user
      return render plain: 'Unauthorized', status: :unauthorized
    end
  end

  helper_method :current_section
  def current_section
    @current_section ||= Section.find(params[:section_id])
  end

  def lesson_params
    params.require(:lesson).permit(:title, :subtitle, :video, :row_order_position)
  end
end

app/controllers/lessons_controller.rb
class LessonsController < ApplicationController

  before_action :authenticate_user!
  before_action :require_current_user_enrolled

  def show

  end

  def require_current_user_enrolled
    if ! current_user.enrolled_in?(current_lesson.section.course)
      redirect_to course_path(current_lesson.section.course), alert: 'Must Enroll To See Lessons'
    end
  end

  private 

  helper_method :current_lesson
  def current_lesson
    @current_lesson ||= Lesson.find(params[:id])
  end
end

app/helpers/instructor/lessons_helper.rb
module Instructor::LessonsHelper
end

app/helpers/lessons_helper.rb
module LessonsHelper
end

app/views/lessons/show.html.erb
<br />

<div class="booyah-box col-10 offset-1" align="center">
  <h2><%= current_lesson.title %></h2>
  <p class="float-left">
    <%= current_lesson.subtitle %>
  </p>

   <% if current_lesson.next_lesson.present? %>
    <%= link_to lesson_path(current_lesson.next_lesson), class: 'btn btn-default float-right' do %>
      Next Lesson &nbsp;
      <span class="fa fa-forward"></span>
    <% end %>
  <% end %>

  <br class="clr" />
  <br />

  <video id="my-video" class="video-js vjs-big-play-centered" controls preload="auto" width="auto" height="auto"
  poster="<%= image_path('black.jpg') %>" data-setup="{}">
    <source src="<%= current_lesson.video.to_s %>" type='video/mp4'>
    <noscript>
      <p class="vjs-no-js">
        To view this video please enable JavaScript, and consider upgrading to a web browser that
        <a href="http://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>
      </p>
    <noscript>
  </video>
  <br />
  <br />
</div>